Subject: bug#43280: 28.0.50; [native-comp] Symbol's function definition is void

From: Rob Moss <[email-masked]>
Date: Sat, 12 Sep 2020 16:59:52 +1000

On Sat, 12 Sep 2020 at 00:44, Andrea Corallo <[email-masked]> wrote:
>
> Rob Moss <[email-masked]> writes:
>
>
> > Hi Andrea,
> >
> > I just tried it with 15acd27d1c0de8b56bab61daa0a8fcd4fef0fdc4 and
> > experienced the same issue.
> >
> > All the best,
> > Rob
>
> Hi Rob,
>
> I had some trouble reproducing with the reproduced as I got a lots of
> errors `Invalid read syntax: "Invalid byte-code object"` byte-compiling
> use-package.  This both on master and feature/native-comp.

Hi Andrea,

I'm sorry, I don't really know how to make a minimal working example
that downloads and installs packages. Do you know of any examples that
I could learn from?

> Anyway I managed to reproduce the issue with elpher installing it
> manually.
>
> I believe the issue is not compiler related, elpher is using `url-port'
> as a generalized variable (line 1326) but ATM I do not see this defined
> anywhere in the Emacs codebase (maybe something was changed?).

I'd never heard of a generalized variable, so I've read some of the
relevant sections of the Emacs manual. I can't tell whether the line
in question:

    (setf (url-port address) (url-port current-address))

should behave "correctly" (whatever that means). But elpher requires
'url-util, which in turns requires 'url-parse. So I would have
expected `url-port' to be a valid function at this point, because it's
defined in lisp/url/url-parse.el. I'm particularly confused because I
only see the warning once elpher has been compiled to native code. So
there does seem to be some difference in behaviour between the byte
code and native code, at least on my computer.

> That said this is a warning and elper for me gets still native compiled
> and I manage to open something as you have suggested evaluating
> (elpher-go "gemini://mozz.us/") also after elpher was loaded as native
> code.

That's interesting, when I see this warning there is nothing else
displayed in the `*elpher*' buffer. It only contains the error message
and a reminder to press `u' to return to the previous page.

> I believe this issue should be reported to the elpher maintainers but to
> a quick search I didn't manage to find if and where the package is still
> maintained.

I've found an email address, so I'll contact the author and see if
they're able to shed any light on this.

Thanks again for your time, patience, and assistance.

All the best,
Rob

>
> Maybe you more info on this.
>
> Thanks
>
>   Andrea